package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowPortDetailsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowPortDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowPortDetailsLogic {
	return &ShowPortDetailsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowPortDetailsLogic) ShowPortDetails(req *types.ShowPortDetailsReq) (resp *types.ShowPortDetailsResp, err error) {
	// todo: add your logic here and delete this line
	ShowPortDetailsReq := &openstack.ShowPortDetailsReq{}
	err = copier.CopyWithOption(ShowPortDetailsReq, req, copier.Option{Converters: utils.Converters})
	ShowPortDetailsResp, err := l.svcCtx.OpenstackRpc.ShowPortDetails(l.ctx, ShowPortDetailsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowPortDetailsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowPortDetailsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
